/*
 *  ALTerator - ALT Linux configuration project
 *
 *  Copyright (c) 2004,2005 ALT Linux Ltd.
 *  Copyright (c) 2004,2005 Alexey Voinov
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 *  USA.
 */
#ifndef MAPPER_HH
#define MAPPER_HH

#include <command.hh>
#include <utils/guile.hh>

struct mapper
{
	struct missing {};

	virtual ~mapper();

	inline command
	operator[](const std::string&) const;

	inline command
	map(const std::string&) const;

	virtual command&
	map(const std::string&, command&) const = 0;
};

class scm_mapper: public mapper
{
	scm::scm data_;

public:
	scm_mapper(const std::string& filename);

	virtual command&
	map(const std::string&, command&) const;
};

inline command
mapper::operator[](const std::string& viewid) const
{
	return map(viewid);
}

inline command
mapper::map(const std::string& viewid) const
{
	command cmd;
	return map(viewid, cmd);
}

#endif // MAPPER_HH
